import java.util.ArrayList;

class Warenkorb extends ArrayList<Ware> { // ArrayList ohne Generics ist auch ok
	public void hineinlegen(Ware ware) {
		add(ware);
	}
}

class Ware {
	public double getPreis() {
		return 0.0;
	}
}

class Marmelade extends Ware {
	public double getPreis() {
		return 2.30;
	}
}

class Quark extends Ware {
	public double getPreis() {
		return 1.30;
	}
}

class Butter extends Ware {
	public double getPreis() {
		return 0.99;
	}
}

public class UE18Aufgabe10 {

	public static void main(String[] args) {
		Warenkorb korb = new Warenkorb();
		einkaufen(korb);
		bezahlen(korb);
	}

	static void einkaufen(Warenkorb korb) {
		korb.hineinlegen(new Marmelade());
		korb.hineinlegen(new Quark());
		korb.hineinlegen(new Butter());
		// ...
	}

	static void bezahlen(Warenkorb korb) {
		double kosten = 0.0;
		for (Ware ware : korb) {
			kosten += ware.getPreis();
		}
		System.out.println("Zu zahlen = " + kosten + " EUR");
	}
}
