class Player {

	private boolean isA;

	public Player(boolean isA) {
		this.isA = isA;
	}

	public int calculate(int currentNumber) {
		int number = IO.readInt("Spieler " + (this.isA ? "A" : "B")
				+ "! Bitte Zahl eingeben: ");
		return number;
	}

}

class Rules {

	public boolean compareNumbers(int oldNumber, int newNumber) {
		int diff = oldNumber - newNumber;
		if (!(diff == 2 || diff == 3)) {
			return false;
		}
		return true;
	}

}

class Game {

	private Rules rules;

	public Game(Rules rules) {
		this.rules = rules;
	}

	public void play(Player playerA, Player playerB) {
		Player currentPlayer = playerA;
		int number = 20;
		System.out.println("Aktuelle Zahl: " + number);
		while (number > 0) {
			int oldNumber = number;
			number = currentPlayer.calculate(oldNumber);
			System.out.println("Aktuelle Zahl: " + number);
			if (!this.rules.compareNumbers(oldNumber, number)) {
				System.out
						.println("Ungueltige Zahl! "
								+ (currentPlayer == playerA ? "Spieler A"
										: "Spieler B") + " hat verloren!");
				return;
			}
			if (number > 0)
				if (currentPlayer == playerA) {
					currentPlayer = playerB;
				} else {
					currentPlayer = playerA;
				}
		}
		System.out.println("Gewonnen hat "
				+ (currentPlayer == playerA ? "Spieler A!" : "Spieler B!"));
	}

}

class TwoThreeGame {

	public static void main(String[] args) {
		Player a = new Player(true);
		Player b = new Player(false);
		Rules rules = new Rules();
		new Game(rules).play(a, b);
	}

}

// ------------------------------------------------------------------
// Loesung beginnt hier !!!
// ------------------------------------------------------------------

public class UE18Aufgabe16 { // OneTwoGame

	public static void main(String[] args) {
		Player a = new OneTwoProgram(true);
		Player b = new Player(false);
		Rules rules = new OneTwoRules();
		new Game(rules).play(a, b);
	}

}

class OneTwoRules extends Rules {

	public boolean compareNumbers(int oldNumber, int newNumber) {
		int diff = oldNumber - newNumber;
		if (!(diff == 1 || diff == 2)) {
			return false;
		}
		return true;
	}

}

class OneTwoProgram extends Player {

	public OneTwoProgram(boolean isA) {
		super(isA);
	}

	public int calculate(int currentNumber) {
		int rest = currentNumber % 3;
		return (rest == 2 ? currentNumber - 2 : currentNumber - 1);
	}

}
